  procedure init;
    var skip: boolean;
        i, argc: integer;
        s, base, lst_name: string[31];

    procedure upstr(var s: string);
      var i: integer;
    begin
    while (length(s) > 0) and (s[1]=' ') do delete(s, 1, 1);
    i:= 0;
    while i < length(s) do
      begin inc(i);
      s[i]:= upcase(s[i]);
      end;
    end; { UpStr }

  begin
  writeln;
  writeln('6800 Cross Assembler.             Version 3.60');
  writeln('Software Research and Development Lab.,  Sofia');
  writeln('Copyright (C) Ivo Nenov 1988-89');
  writeln('          (C) O.Shopov  1988-89 Eagle software');
  writeln('          (C) G.Petrov  1988-91 YGP');
  writeln;
  errfile:= false;
  Assign(StdOut, ''); rewrite(StdOut);
  Inc_Fname[0]:= ''; IncLines[0]:= 0; IncLevel:= 0;
  instructions:= instr_def;
  has_lst:= false;
  relative_mode:= true; pgm_mode:= true;
  org_found:= false;
  csum_found := false;
  argc:= paramcount;
  cind:= 0; buff_over:= false; ipc:= 0; entry_point:= 0;
  offset_ind:= 0;
  n_errors:= 0; n_warns:= 0; end_found:= false; not_dummy:= true; gen_list:= true;
  digits:= '0123456789ABCDEF';
  directives[ 0+0]:= '.DEFINE';
  directives[ 0+1]:= '.ELSE';
  directives[ 0+2]:= '.ENDIF';
  directives[ 0+3]:= '.IFDEF';
  directives[ 0+4]:= '.IFNDEF';
  directives[ 0+5]:= '.UNDEF';
  directives[ 0+6]:= '=';
  directives[ 1+6]:= 'CHECKSUM';
  directives[ 2+6]:= 'DB';
  directives[ 3+6]:= 'DS';
  directives[ 4+6]:= 'DW';
  directives[ 5+6]:= 'END';
  directives[ 6+6]:= 'ENDP';
  directives[ 7+6]:= 'ENDS';
  directives[ 8+6]:= 'EQU';
  directives[ 9+6]:= 'ERROR';
  directives[10+6]:= 'EXTERN';
  directives[11+6]:= 'GLOBAL';
  directives[12+6]:= 'INCLUDE';
  directives[13+6]:= 'LIST';
  directives[14+6]:= 'ORG';
  directives[15+6]:= 'PROC';
  directives[16+6]:= 'PUBLIC';
  directives[17+6]:= 'RADIX';
  directives[18+6]:= 'SECTION';
  directives[19+6]:= 'TRUNC';
  radix:= 10;
  new(out_buff);
  new(offsets);
  fillchar(offsets^, sizeof(offsets^), 0);
  new(publics_ptr); new(externals_ptr);
  n_publics:= 0; n_externals:= 0;

  f_parent.kind:= 3;
  f_parent.parent:= nil;
  f_parent.locals:= nil;
  f_parent.offset:= 0; f_parent.constant:= false;


  if argc < 1 then
    begin
    write('Source filename [.ASM]: ');
    readln(s);
    end
  else s:= paramstr(1);
  upstr(s);
  i:= pos(';', s); skip:= i<>0;
  if skip then s[0]:= chr(i-1);
  base:= s;
  i:= pos('.', base);
  if i <> 0 then base[0]:= chr(i-1)         { this should be i-1 rather than i, Eagle }
  else s:= concat(s, '.ASM');
  assign(incld[0], s); reset(incld[0]); inc_clevel[0]:= 0;
  inc_fname[0]:= s;
  if ioresult<>0 then error(c_open_src, 0);
  Assign(StdErr, base + '.ERR');
  obj_fname:= base;
(*  if errfile then rewrite(StdErr); *)
  if skip then exit;

  if argc >= 2 then
    s:= paramstr(2)
  else begin
    write('Listing filename [.LST]: '); readln(s);
  end { if };
  upstr(s);
  i:= pos(';', s); skip:= i<>0;
  if skip then s[0]:= chr(i-1);
  if (length(s) <> 0) and (s <> 'NUL') then begin
    if pos('.',s) = 0 then s:= concat(s, '.LST');
    assign(lst, s); rewrite(lst);
    MayCon:= s = 'CON.';
    if ioresult = 0 then
      has_lst:= true
    else begin
      error(c_open_lst, 2);
    end { if };
  end { if };
  if skip then exit;

  if argc < 3 then
    begin
    write('Object filename [', base,'.PGM]: ');
    readln(s); upstr(s);
    end
  else s:= paramstr(3);
  i:= pos(';', s); skip:= i<>0;
  if i>0 then s[0]:= chr(i-1);
  if s<>'' then
    begin
    i:= pos('.', s);
    obj_fname:= s;
    if i>0 then
      begin
      obj_fname[0]:= chr(i - 1);
      delete(s, 1, i);
      if s = 'OBJ' then pgm_mode:= false;
      end;
    end;
  end; { init }
